/*
google.c - Google hack for RSStool

Copyright (c) 2006 NoisyB


This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#ifdef  HAVE_CONFIG_H
#include "config.h"
#endif
#include <stdio.h>
#include <time.h>
#include "misc/net.h"
#include "misc/xml.h"
#include "misc/string.h"
#include "misc/rss.h"
#include "misc/file.h"
#include "rsstool_defines.h"
#include "rsstool.h"
#include "rsstool_misc.h"
#include "google.h"


#if 0
Google hacking at its finest..

Using Google, and some finely crafted searches we can find a lot of
interesting information.

For Example we can find:
Credit Card Numbers
Passwords
Software / MP3's

...... (and on and on and on) 

Presented below is just a sample of interesting searches that we can send to
google to obtain info that some people might not want us having.. After you
get a taste using some of these, try your own crafted searches to find info
that you would be interested in.

Try a few of these searches:
intitle:"Index of" passwords modified
allinurl:auth_user_file.txt
"access denied for user" "using password"
"A syntax error has occurred" filetype:ihtml
allinurl: admin mdb
"ORA-00921: unexpected end of SQL command"
inurl:passlist.txt
"Index of /backup"
"Chatologica MetaSearch" "stack tracking:"

Amex Numbers: 300000000000000..399999999999999
MC Numbers: 5178000000000000..5178999999999999
visa 4356000000000000..4356999999999999

"parent directory " /appz/ -xxx -html -htm -php -shtml -opendivx -md5 -md5sums

"parent directory " DVDRip -xxx -html -htm -php -shtml -opendivx -md5 -md5sums

"parent directory "Xvid -xxx -html -htm -php -shtml -opendivx -md5 -md5sums

"parent directory " Gamez -xxx -html -htm -php -shtml -opendivx -md5 -md5sums

"parent directory " MP3 -xxx -html -htm -php -shtml -opendivx -md5 -md5sums

"parent directory " Name of Singer or album -xxx -html -htm -php -shtml -opendivx -md5 -md5sums

Notice that I am only changing the word after the parent directory, change
it to what you want and you will get a lot of stuff.

METHOD 2

put this string in google search:

?intitle:index.of? mp3

You only need add the name of the song/artist/singer.

Example: ?intitle:index.of? mp3 jackson

METHOD 3

put this string in google search:

inurl:microsoft filetype:iso

You can change the string to watever you want, ex. microsoft to adobe, iso to zip etc

"# -FrontPage-" inurl:service.pwd
Frontpage passwords.. very nice clean search results listing !!

"AutoCreate=TRUE password=*"

This searches the password for "Website Access Analyzer", a Japanese
software that creates webstatistics. For those who can read Japanese, check
out the author's site at: http://www.coara.or.jp/~passy/

"http://*:*@www" domainname

This is a query to get inline passwords from search engines (not just
Google), you must type in the query followed with the the domain name
without the .com or .net

"http://*:*@www" bangbus or "http://*:*@www"bangbus

Another way is by just typing
"http://bob:bob@www"

"sets mode: +k"

This search reveals channel keys (passwords) on IRC as revealed from IRC
chat logs.

allinurl: admin mdb

Not all of these pages are administrator's access databases containing
usernames, passwords and other sensitive information, but many are!

allinurl:auth_user_file.txt

DCForum's password file. This file gives a list of (crackable) passwords,
usernames and email addresses for DCForum and for DCShop (a shopping cart
program(!!!). Some lists are bigger than others, all are fun, and all belong
to googledorks. =)


intitle:"Index of" config.php

This search brings up sites with "config.php" files. To skip the technical
discussion, this configuration file contains both a username and a password
for an SQL database. Most sites with forums run a PHP message base. This
file gives you the keys to that forum, including FULL ADMIN access to the
database.

eggdrop filetype:user user

These are eggdrop config files. Avoiding a full-blown descussion about
eggdrops and IRC bots, suffice it to say that this file contains usernames
and passwords for IRC users.

intitle:index.of.etc

This search gets you access to the etc directory, where many many many types
of password files can be found. This link is not as reliable, but crawling
etc directories can be really fun!

filetype:bak inurl:"htaccess|passwd|shadow|htusers"

This will search for backup files (*.bak) created by some editors or even by
the administrator himself (before activating a new version). Every attacker
knows that changing the extenstion of a file on a webserver can have ugly
consequences.

Let's pretend you need a serial number for windows xp pro.

In the google search bar type in just like this - "Windows XP Professional" 94FBR

the key is the 94FBR code.. it was included with many MS Office registration
codes so this will help you dramatically reduce the amount of 'fake' porn
sites that trick you. or if you want to find the serial for winzip 8.1 -
"Winzip 8.1" 94FBR


Basic Usage:

Use quotation marks   to locate an entire string.
eg. bill gates conference will only return results with that exact string.

Mark essential words with a +

If a search term must contain certain words or phrases, mark it with a +
symbol. eg: +bill gates conference will return all results containing bill
gates but not necessarily those pertaining to a conference

Negate unwanted words with a -

You may wish to search for the term bass, pertaining to the fish and be
returned a list of music links as well. To narrow down your search a bit
more, try: bass -music. This will return all results with bass and NOT
music.

General Tips: (I use many of these almost on a daily basis)

site:www.cwire.org
This will search only pages which reside on this domain.

related:www.cwire.org
This will display all pages which Google finds to be related to your URL

link:www.cwire.org
This will display a list of all pages which Google has found to be linking
to your site. Useful to see how popular your site is

spell:word
Runs a spell check on your word

define:word
Returns the definition of the word

stocks: [symbol, symbol, etc]
Returns stock information. eg. stock: msft

maps:
A shortcut to Google Maps

phone: name_here
Attempts to lookup the phone number for a given name

cache:
If you include other words in the query, Google will highlight those words
within the cached document. For instance, cache:www.cwire.org web will show
the cached content with the word web highlighted.

info:
The query [info:] will present some information that Google has about that
web page. For instance, info:www.cwire.org will show information about the
CyberWyre homepage. Note there can be no space between the info: and the web
page url.

weather:
Used to find the weather in a particular city. eg. weather: new york

Advanced Tips:

filetype:
Does a search for a specific file type, or, if you put a minus sign (-) in
front of it, it wont list any results with that filetype. Try it with .mp3,
.mpg or .avi if you like.

daterange:
Is supported in Julian date format only. 2452384 is an example of a Julian
date.

allinurl:
If you start a query with [allinurl:], Google will restrict the results to
those with all of the query words in the url. For instance, [allinurl:
google search] will return only documents that have both google and search
in the url.

inurl:
If you include [inurl:] in your query, Google will restrict the results to
documents containing that word in the url. For instance, [inurl:google
search] will return documents that mention the word google in their url, and
mention the word search anywhere in the document (url or no). Note there can
be no space between the inurl: and the following word.

allintitle:
If you start a query with [allintitle:], Google will restrict the results to
those with all of the query words in the title. For instance, [allintitle:
google search] will return only documents that have both google and search
in the title.

intitle:
If you include [intitle:] in your query, Google will restrict the results to
documents containing that word in the title. For instance, [intitle:google
search] will return documents that mention the word google in their title,
and mention the word search anywhere in the document (title or no). Note
there can be no space between the intitle: and the following word.

allinlinks:
Searches only within links, not text or title.

allintext:
Searches only within text of pages, but not in the links or page title.

bphonebook:
If you start your query with bphonebook:, Google shows U.S. business white
page listings for the query terms you specify. For example, [ bphonebook:
google mountain view ] will show the phonebook listing for Google in
Mountain View.

phonebook:
If you start your query with phonebook:, Google shows all U.S. white page
listings for the query terms you specify. For example, [ phonebook: Krispy
Kreme Mountain View ] will show the phonebook listing of Krispy Kreme donut
shops in Mountain View.

rphonebook:
If you start your query with rphonebook:, Google shows U.S. residential
white page listings for the query terms you specify. For example, [
rphonebook: John Doe New York ] will show the phonebook listings for John
Doe in New York (city or state). Abbreviations like [ rphonebook: John Doe
NY ] generally also work.

Putting it all Together: 

Now its time to start to get creative with our search terms and really
narrow down our results. Now that we have the basics, lets start to combine
them all into one search term.

Example #1: Search for some MP3s
Lets say youre a Beatles fan and want to see if you can find some of their
songs on the Internet without using Kazaa, etc. Try this query:

    index of + mp3 + beatles -html -htm -php
    or you could try this query:
index of/mp3 -playlist -html -lyrics beatles

Right away on the first few results returned by Google you can download MP3s.

Example #2: Mixing some techniques together

Heres a simple exercise. Well mix around a few terms to get more accurate
results. Lets say we want to research sleep recommendations. One assumption
could be that research papers on this topic would most likely be on an
educational website perhaps with a .edu domain. We could try this query:

    sleep recommendations site:edu

Maybe were in my situation, and am thinking of applying to grad school. Lets
see if we can find the Graduate Studies Admissions Requirements at the
University of Toronto. We could try this query:

    grad school admission requirements site:utoronto.ca

Summary:

After reading this article, you might be thinking well, I could probably
find those results without remembering these advanced search terms. Well,
the truth is that you probably could. The reason you want to start to use
these advanced search tips is because they will help you find what youre
looking for faster. They greatly help narrow down the results, and more
often than not, the information you were looking for will be in the first
two or three results.


google: allinurl:rss filetype:xml -html -php -htm
google: SEARCH ext:torrent
http://www.google.com/search?hl=en&client=opera&rls=en&q=intitle%3A%28%22Index.of.*%22%7C%22Index.von.*%22%29+%2B%28Verzeichnis%7Cdirectory%29+-inurl%3A%28htm%7Cphp%7Chtml%7Cpy%7Casp%7Cpdf%29+-inurl%3Ainurl+-inurl%3Aindex+super+nintendo&btnG=Search
intitle:("Index.of.*"|"Index.von.*") +(Verzeichnis|directory) -inurl:(htm|php|html|py|asp|pdf) -inurl:inurl -inurl:index super nintendo
#endif


#define GOOGLE_MAX_RESULTS 2000
#define GOOGLE_URL_S "http://www.google.com"
#define GOOGLE_SEARCH_S GOOGLE_URL_S "/search?q=%s&num=100"
//#define GOOGLE_SEARCH_LANG_S "&lr=lang_%s"
#define GOOGLE_SEARCH_START_S "&start=%d&sa=N"


static FILE *fh = NULL;


#if 0
<!--m-->
<h2 class="r">
  <a href="http://www.oekotest.de/" class="l">www.oekotest.de (ho)</a>
</h2>
<table border="0" cellpadding="0" cellspacing="0">
  <tbody>
    <tr>
      <td class="j">
        <font size="-1">
          Verlag f<C3><BC>r <C3><B6>kologische Zeitschriften in Deutschland (<C3><96>ko-<b>Test</b>-Magazin, <C3><96>ko-Haus). Informiert <C3><BC>ber Produkte, Preise, Bestellm<C3><B6>glichkeiten, Archiv.<br>
          <span class="a">www.oeko<b>test</b>.de/ - 17. Apr. 2007 - </span>
          <nobr>
            <a class="fl" href="http://www.google.de/search?hl=de&amp;q=related:www.oekotest.de/"><C3><84>hnliche Seiten
            </a>
          </nobr>
        </font>
<!--n-->
#endif


static const char *
a_filter (const char *s)
{
  char title[MAXBUFSIZE];
  char link[MAXBUFSIZE];
  char desc[MAXBUFSIZE];
  const char *p = NULL;

  // a new item
  *title = *link = *desc = 0;

  // google links contain class="l"
  p = xml_tag_get_value (s, "class");
  if (!p)
    return "";

  if (stricmp (p, "l"))
    return "";

  p = xml_tag_get_value (s, "href");
  if (!p)
    return "";

  if (stristr (p, "http"))
    strncpy (link, p, MAXBUFSIZE)[MAXBUFSIZE - 1] = 0;

  if (*title && *link && *desc)
    rsstool_add_item_s (&rsstool,
                        "Google",
                        "--google",
                        time (0),
                        link,
                        link,
                        "");

  return "";
}


st_tag_filter_t google_item_filter[] = {
  {
    "a",
    a_filter
  },
  {NULL, NULL}
};


int
google_hack (st_rsstool_t *rt, const char *search)
{
  (void) rt;
  st_net_t *n = NULL;
  char buf[MAXBUFSIZE];
  char search_esc[MAXBUFSIZE];
  int cf = 0;
  int count = 0;
  const char *temp = NULL;
//  FILE *fh = NULL;

  if (!search)
    return -1;

  if (!(n = net_init (0)))
    {
      fprintf (stderr, "ERROR: google_hack()/net_init() failed\n");
      return -1;
    }

  stresc (search_esc, search);

  for (count = 0; count < GOOGLE_MAX_RESULTS; count += 100)
    {
      if (net_open (n, GOOGLE_URL_S, 80) != 0)
        {
          fprintf (stderr, "ERROR: could not log on to %s\n", GOOGLE_URL_S);
          return -1;
        }

      sprintf (buf, GOOGLE_SEARCH_S, search_esc);
      if (count)
        sprintf (strchr (buf, 0), GOOGLE_SEARCH_START_S, count);

      rsstool_log (&rsstool, buf);      

      temp = net_http_get_to_temp (buf, rsstool.user_agent, rsstool.get_flags);
      if (!temp)
        {
          fprintf (stderr, "ERROR: failed to download %s\n", buf);
          continue;
        }

      if (!(fh = fopen (temp, "rb")))
        continue;

      while (fgets (buf, MAXBUFSIZE, fh))
        cf = xml_tag_filter (buf, google_item_filter, cf);

      fclose (fh);

      // remove temp file
      remove (temp);
    }

  return 0;
}


